import { Nat, Z, S } from "nat-ts";
export { Nat, Z, S };
export declare namespace HelpConfig {
    const minMaxWidth = 30;
}
export interface HelpConfig {
    maxWidth: number;
    helpGroupFilter?: string[];
}
export interface FixedArray<T> {
    "1": [T];
    "2": [T, T];
    "3": [T, T, T];
    "4": [T, T, T, T];
    "5": [T, T, T, T, T];
    "6": [T, T, T, T, T, T];
    "7": [T, T, T, T, T, T, T];
    "8": [T, T, T, T, T, T, T, T];
    "9": [T, T, T, T, T, T, T, T, T];
    "10": [T, T, T, T, T, T, T, T, T, T];
    "11": [T, T, T, T, T, T, T, T, T, T, T];
    "12": [T, T, T, T, T, T, T, T, T, T, T, T];
    "13": [T, T, T, T, T, T, T, T, T, T, T, T, T];
    "14": [T, T, T, T, T, T, T, T, T, T, T, T, T, T];
    "15": [T, T, T, T, T, T, T, T, T, T, T, T, T, T, T];
    "16": [T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T];
    "17": [T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T];
    "18": [T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T];
    "19": [T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T];
    "20": [T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T, T];
}
export declare type Callback0 = () => void;
export declare type Callback1<TypeMap, A extends keyof TypeMap> = (a: TypeMap[A]) => void;
export declare type Callback2<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B]) => void;
export declare type Callback3<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C]) => void;
export declare type Callback4<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D]) => void;
export declare type Callback5<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D], e: TypeMap[E]) => void;
export declare type Callback6<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D], e: TypeMap[E], f: TypeMap[F]) => void;
export declare type Callback7<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D], e: TypeMap[E], f: TypeMap[F], g: TypeMap[G]) => void;
export declare type Callback8<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap, H extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D], e: TypeMap[E], f: TypeMap[F], g: TypeMap[G], h: TypeMap[H]) => void;
export declare type Callback9<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap, H extends keyof TypeMap, I extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D], e: TypeMap[E], f: TypeMap[F], g: TypeMap[G], h: TypeMap[H], i: TypeMap[I]) => void;
export declare type Callback10<TypeMap, A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap, H extends keyof TypeMap, I extends keyof TypeMap, J extends keyof TypeMap> = (a: TypeMap[A], b: TypeMap[B], c: TypeMap[C], d: TypeMap[D], e: TypeMap[E], f: TypeMap[F], g: TypeMap[G], h: TypeMap[H], i: TypeMap[I], j: TypeMap[J]) => void;
export declare type Description = string;
export declare type Keyword = string | string[] | [string[], string];
export declare type Arg<TypeName extends (string | [string])> = [TypeName, string] | {
    typeName: TypeName;
    argText: string;
};
export interface NoParse {
    readonly __NoParse: void;
}
export declare const NoParse: NoParse;
export declare type Parser<T> = (startIndex: number, args: string[]) => [T | NoParse, number];
export declare type SimpleParser<T> = (arg: string) => T | NoParse;
export declare function simpleParse<T>(parser: (s: string) => T | NoParse): Parser<T>;
export declare function parseString(arg: string): string | NoParse;
export declare function parseBoolean(arg: string): boolean | NoParse;
export declare function parseNumber(arg: string): number | NoParse;
export declare function parseInteger(arg: string): number | NoParse;
export declare function parseUnsigned(arg: string): number | NoParse;
export declare const parseInt8: SimpleParser<number>;
export declare const parseInt16: SimpleParser<number>;
export declare const parseInt32: SimpleParser<number>;
export declare const parseUint8: SimpleParser<number>;
export declare const parseUint16: SimpleParser<number>;
export declare const parseUint32: SimpleParser<number>;
export declare function createOptionalParser<T>(parser: Parser<T>): Parser<T | undefined>;
export declare function createFixedArrayParser<T, N extends keyof FixedArray<T>>(sizeLiteral: N, parser: Parser<T>): Parser<FixedArray<T>[N]>;
export declare function createArrayParser<T>(parser: Parser<T>): Parser<T[]>;
export declare function createUnionParser<A, B>(parserA: Parser<A>, parserB: Parser<B>): Parser<A | B>;
export declare const parseInt8Array: Parser<Int8Array>;
export declare const parseInt16Array: Parser<Int16Array>;
export declare const parseInt32Array: Parser<Int32Array>;
export declare const parseUint8Array: Parser<Uint8Array>;
export declare const parseUint16Array: Parser<Uint16Array>;
export declare const parseUint32Array: Parser<Uint32Array>;
export declare class Exception extends Error {
    protected constructor(message: string);
}
export declare class RegistrationException extends Exception {
    constructor(conflictingTypeName: string);
    readonly conflictingTypeName: string;
}
export declare class OptionsStateException extends Exception {
    constructor(message: string);
}
export declare class ParseException extends Exception {
    static create(beginArgsIndex: number, endArgsIndex: number, args: string[]): ParseException;
    protected constructor(args: string[], message: string);
    readonly args: string[];
}
export declare class BadInputException extends ParseException {
    constructor(keywordArgsIndex: number, badArgsIndex: number, args: string[]);
    readonly keywordArgsIndex: number;
    readonly badArgsIndex: number;
}
export declare class UnknownOptionException extends ParseException {
    constructor(keywordArgsIndex: number, args: string[]);
    readonly keywordArgsIndex: number;
}
export declare class EndOfInputException extends ParseException {
    constructor(keywordArgsIndex: number, args: string[]);
    readonly keywordArgsIndex: number;
}
export declare class ParseContext {
    constructor(impl: any, args: string[]);
    run(): void;
    private _matchOptionKeyword(option, argsIndex);
    private _tryParse();
    protected readonly __ParseContext: void;
    private readonly _impl;
    private readonly _args;
}
export declare class Options<TypeMap, N extends Nat> {
    private constructor();
    static createRaw(): Options<{}, Z>;
    static createDefault(): Options<{
        boolean: boolean;
    } & {
        "boolean?"?: boolean | undefined;
    } & {
        "boolean[]": boolean[];
    } & {
        string: string;
    } & {
        "string?"?: string | undefined;
    } & {
        "string[]": string[];
    } & {
        number: number;
    } & {
        "number?"?: number | undefined;
    } & {
        "number[]": number[];
    } & {
        integer: number;
    } & {
        "integer?"?: number | undefined;
    } & {
        "integer[]": number[];
    } & {
        unsigned: number;
    } & {
        "unsigned?"?: number | undefined;
    } & {
        "unsigned[]": number[];
    } & {
        Int8: number;
    } & {
        "Int8?"?: number | undefined;
    } & {
        "Int8[]": number[];
    } & {
        Int16: number;
    } & {
        "Int16?"?: number | undefined;
    } & {
        "Int16[]": number[];
    } & {
        Int32: number;
    } & {
        "Int32?"?: number | undefined;
    } & {
        "Int32[]": number[];
    } & {
        Uint8: number;
    } & {
        "Uint8?"?: number | undefined;
    } & {
        "Uint8[]": number[];
    } & {
        Uint16: number;
    } & {
        "Uint16?"?: number | undefined;
    } & {
        "Uint16[]": number[];
    } & {
        Uint32: number;
    } & {
        "Uint32?"?: number | undefined;
    } & {
        "Uint32[]": number[];
    } & {
        Int8Array: Int8Array;
    } & {
        Int16Array: Int16Array;
    } & {
        Int32Array: Int32Array;
    } & {
        Uint8Array: Uint8Array;
    } & {
        Uint16Array: Uint16Array;
    } & {
        Uint32Array: Uint32Array;
    }, S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<S<Z>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>;
    registerParsers<TypeName extends string, OptionalTypeName extends string, ArrayTypeName extends string, Type>(typeName: TypeName, optionalTypeName: OptionalTypeName, arrayTypeName: ArrayTypeName, simpleParser: SimpleParser<Type>): Options<TypeMap & {
        [P in TypeName]: Type;
    } & {
        [P in OptionalTypeName]?: Type;
    } & {
        [P in ArrayTypeName]: Type[];
    }, S<S<S<N>>>>;
    private static _cannotCallException(caller, invalidatingCall);
    private static _nullImplException(caller);
    registerParser<TypeName extends string, Type>(typeName: TypeName, parser: Parser<Type>): Options<TypeMap & {
        [P in TypeName]: Type;
    }, S<N>>;
    setHelpGroupPriority(helpGroup: string, priority: number): void;
    addOption(keyword: Keyword, text: Description, func: Callback0): void;
    addOption<A extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, text: Description, func: Callback1<TypeMap, A>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, text: Description, func: Callback2<TypeMap, A, B>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, text: Description, func: Callback3<TypeMap, A, B, C>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, text: Description, func: Callback4<TypeMap, A, B, C, D>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, e: Arg<E>, text: Description, func: Callback5<TypeMap, A, B, C, D, E>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, e: Arg<E>, f: Arg<F>, text: Description, func: Callback6<TypeMap, A, B, C, D, E, F>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, e: Arg<E>, f: Arg<F>, g: Arg<G>, text: Description, func: Callback7<TypeMap, A, B, C, D, E, F, G>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap, H extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, e: Arg<E>, f: Arg<F>, g: Arg<G>, h: Arg<H>, text: Description, func: Callback8<TypeMap, A, B, C, D, E, F, G, H>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap, H extends keyof TypeMap, I extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, e: Arg<E>, f: Arg<F>, g: Arg<G>, h: Arg<H>, i: Arg<I>, text: Description, func: Callback9<TypeMap, A, B, C, D, E, F, G, H, I>): void;
    addOption<A extends keyof TypeMap, B extends keyof TypeMap, C extends keyof TypeMap, D extends keyof TypeMap, E extends keyof TypeMap, F extends keyof TypeMap, G extends keyof TypeMap, H extends keyof TypeMap, I extends keyof TypeMap, J extends keyof TypeMap>(keyword: Keyword, a: Arg<A>, b: Arg<B>, c: Arg<C>, d: Arg<D>, e: Arg<E>, f: Arg<F>, g: Arg<G>, h: Arg<H>, i: Arg<I>, j: Arg<J>, text: Description, func: Callback10<TypeMap, A, B, C, D, E, F, G, H, I, J>): void;
    static queryStringToArgs(queryString: string, arrayFormat?: "bracket" | "index" | "none"): string[];
    createParseContext(args: string[]): ParseContext;
    getHelpDescription(config?: HelpConfig): string;
    protected readonly __Options: void;
    private _impl;
    private _spawnedParseContexts;
}
