"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lambda_options_1 = require("./lambda-options");
var options = lambda_options_1.Options.createDefault();
options.setHelpGroupPriority("help", -1);
options.addOption(["--help", "-h"], "Display this help message.", function () {
    console.log(options.getHelpDescription());
});
options.addOption("--take", ["unsigned", "NUM"], ["string", "STR"], "Takes the first NUM characters of STR.", function (n, s) {
    console.log(s.substr(0, n));
});
options.addOption("--sum", ["number", "NUM"], ["number[]", "NUMS"], "Takes the sum of 1 or more numbers.", function (x, xs) {
    console.log(xs.reduce(function (y, z) { return y + z; }, x));
});
var args = process.argv.slice(2);
var parseContext = options.createParseContext(args);
try {
    parseContext.run();
}
catch (e) {
    if (e instanceof lambda_options_1.Exception) {
        console.log(e.message);
    }
    else {
        console.log(e);
    }
}
